// ************************************************************
//	Clean Linear Algebra Subroutines - CLAS
//	Version 0.5 - October 6, 1998 - Thorsten Zoerner
// 	Catholic University of Nijmegen - zoerner@cs.kun.nl
// ************************************************************

definition module Clas2

import Clas1, SampleMat, StdMisc

class MatrixVectorProduct a
where
	(**) infix 7 :: a Vector -> Vector
	
instance MatrixVectorProduct {#{# Real}}

transpose 		:: .Matrix -> .Matrix

forwardSubst 	:: Matrix Vector -> *Vector	// Solve a system
											// with a lower left
											// triangular system 
backwardSubst 	:: Matrix Vector -> *Vector	// Solve a system
											// with a upper right
											// triangular system *)
// use with LU factorization Ax=LUx=b <==> Ly=b, Ux=y
// cf. solve in Clas3

// *)	assuming that only ones are on the diagonal, which is the case 
//		after the LU factorization


